import { Listener, ObserverValues, SetOptions, StarOrKey, BindObserver, GlobalState, GlobalStatics } from '../types';
declare class Observer<T = Record<string, any>, S = Record<string, any>> {
    #private;
    statics: S;
    constructor(initialValues?: T, statics?: BindObserver<S, T>);
    setStatics(statics?: BindObserver<S, T>): void;
    subscribe<StateType extends T>(key: StarOrKey<keyof StateType> | Array<keyof StateType>, listener: Listener): () => void;
    set<StateType>(values: ObserverValues<StateType, T>, { silent }?: SetOptions): void;
    get<StateType extends T & S>(key: keyof StateType | Array<keyof StateType>): any;
    get state(): T;
    isValid(key: string): boolean;
}
declare const observer: Observer<GlobalState, GlobalStatics>;
export { Observer, observer };
